unit hiCallDllEx;

interface

uses Kol,Share,Windows,Debug,DLLLoader;

type
  THICallDllEx = class(TDebug)
   private
    FData: TData;
    DLLHandle : THandle;      //      
    Loader: TDLLLoader;       //     c 
    FIndex:integer;
    FList:PStrList;
    FFuncList:PStrList;
    Arr:PArray;

    procedure SetText(const Value:string);
    procedure _Set(var Item:TData; var Val:TData);
    function _Get(Var Item:TData; var Val:TData):boolean;
    function _Count:integer;
    procedure _Add(var Val:TData);

   public
    _prop_DLLName:string;
    _prop_InStream:boolean;
    _prop_CallType:Integer;

    _event_onLog:THI_Event;
    _event_onProc:THI_Event;
    _event_onFunc:THI_Event;
    _event_onDLLExports:THI_Event;
    _data_StreamDLL:THI_Event;
    _data_DLLName:THI_Event;
    _data_Data:THI_Event;

    constructor Create;
    destructor Destroy; override;
    procedure LogCreate(const idx: integer);
    procedure Init;
    function CallFuncInt: Integer;
    function CallFuncDbl: Double;

    procedure _work_doListDLLExports(var _Data:TData; Index:word);
    procedure _work_doCallFuncStr(var _Data:TData; Index:word);
    procedure _work_doDLLName(var _Data:TData; Index:word);
    procedure _work_doFuncList(var _Data:TData; Index:word);
    procedure _var_ArrFunc(var _Data:TData; Index:word);
    procedure _var_Count(var _Data:TData; Index:word);
    procedure _var_Name(var _Data:TData; Index:word);
    procedure _var_Data(var _Data:TData; Index:word);
    property _prop_FuncList:string write SetText;
  end;

implementation
var
    DllNameStr: string;       //  
    FuncNameStr: string;      //   
    ResTypeChr: Char;         //     
    DLLStream: PStream;       //     
    Param: PStream;           //  
    ParamSize: Integer;       //    
    Func: Pointer;            //     
    ParamType: string;        //    
    CallType: Integer;        //   stdcall/cdecl

    tmpStr: string;
    tmpInt: Integer;
    tmpDbl: Double;
    tmpSingle: Single;
    tmpCurrency: Currency;
    tmpComp: Comp;
    tmpDt: TData;

procedure Explode(var a: array of string; Border, S: string);
var
   S2: string;
   i: Integer;
begin
   i  := 0;
   S2 := S + Border;
   repeat
     a[i] := Copy(S2, 0,Pos(Border, S2) - 1);
     Delete(S2, 1,Length(a[i] + Border));
     Inc(i);
   until S2 = '';
end;

constructor THICallDllEx.Create;
begin
  inherited  Create;
  FList := NewStrList;
  FFuncList := NewStrList;
  FIndex := -1;
  InitAdd(Init);
end;

destructor THICallDllEx.Destroy;
begin
  Loader.Free;
  FreeLibrary(DLLHandle);
  FList.Free;
  if Arr <> nil then dispose(Arr);
  inherited Destroy;
end;

procedure THICallDllEx.Init;
var dt:TData;
begin
  CallType := _prop_CallType;
  dt := _doData(_prop_DLLName);
  _work_doDLLName(dt,0);
end;

procedure THICallDllEx._work_doCallFuncStr;
 var
   S: string;
   A: array of String;
   i: Integer;
begin
   Param := NewMemoryStream;
   ParamSize := 0;
   S := ToString(_Data);
   SetLength(A, 10);
   Explode(A, ';', S);
   FuncNameStr := A[0];
   ParamType := A[1];
   ResTypeChr := A[2,1];
   for i:=1 to Length(ParamType) do begin
     tmpstr := A[i+2];
     Case ParamType[i] of
       'I': begin tmpint:=Str2Int(tmpstr); Param.Write(tmpint, 4); end; //Integer
       'i': begin tmpint:=SmallInt(Str2Int(tmpstr)); Param.Write(tmpint, 4); end; //SmallInt
       'o': begin tmpint:=ShortInt(Str2Int(tmpstr)); Param.Write(tmpint, 4); end; //ShortInt
       'B': begin tmpint:=Integer(Byte(Str2Int(tmpstr))); Param.Write(tmpint, 4); end; //Bute
       'b': begin tmpint:=Integer(Boolean(Str2Int(tmpstr))); Param.Write(tmpint, 4); end; //Boolean
       'W': begin tmpint:=Word(Str2Int(tmpstr)); Param.Write(tmpint, 4); end;       //Word
       'L': begin tmpint:=Str2Int(tmpstr); Param.Write(DWord(tmpint), 4); end;      //LongWord
       'h': begin tmpint:=Str2Int(tmpstr); Param.Write(Cardinal(tmpint), 4); end;   //Cardinal
       'R': begin tmpdbl:=Str2Double(tmpstr); Param.Write(tmpdbl, 8); end;           //Real
       'D': begin tmpdbl:=Str2Double(tmpstr); Param.Write(tmpdbl, 8); end;           //Double
       'd': begin tmpSingle:=Str2Double(tmpstr); Param.Write(tmpSingle, 4); end;     //Single
       'C': begin tmpCurrency:=Str2Double(tmpstr); Param.Write(tmpCurrency, 8); end; //Currency
       'c': begin tmpComp:=Str2Double(tmpstr); Param.Write(tmpComp, 8); end;         //Comp
       // 'S': Param.Write(tmpStr[1], Length(tmpStr));    //String
       'S': Param.Write(tmpStr, 4);    //String
       's': Param.Write(tmpStr, 4);    //PChar
       'a': Param.Write(tmpStr[1], 4); //Char
     end;
   end;
  ParamSize:=Param.Size;
  //   ( )
  //Param:=Ptr(cardinal(Param.Memory) + (Param.Size - 4));   //delphi
  if Param.Size > 0 then
  Param:=Pointer(cardinal(Param.Memory) + (Param.Size - 4)); //fpc
  LogCreate(8);

  case _prop_InStream of
    False: begin
      if (Length(FuncNameStr) > 0) and (DLLHandle <> 0) then
        begin
          Func := GetProcAddress(DLLHandle, PChar(FuncNameStr));
          if Func = nil then begin
            LogCreate(7);
            exit;
          end;
        end else begin
          LogCreate(6);
          exit;
      end;
    end;
    True: begin
      if (Length(FuncNameStr) > 0) and (Loader <> nil) then
        begin
          Func := Loader.FindExport(PChar(FuncNameStr));
          if Func = nil then begin
            LogCreate(7);
            exit;
          end;
        end else begin
          LogCreate(6);
          exit;
      end;
    end;
  end;

  case ResTypeChr of
    'N': begin tmpDt.Data_type := data_null; CallFuncInt; _hi_OnEvent(_event_onProc, tmpDt); end;
    'b': begin tmpDt.Data_type := data_int; tmpDt.idata := Integer(Boolean(CallFuncInt)); _hi_OnEvent(_event_onFunc, tmpDt); end ;//Boolean
    'o': begin tmpDt.Data_type := data_int; tmpDt.idata := Shortint(CallFuncInt); _hi_OnEvent(_event_onFunc, tmpDt); end; //Shortint
    'i': begin tmpDt.Data_type := data_int; tmpDt.idata := SmallInt(CallFuncInt); _hi_OnEvent(_event_onFunc, tmpDt); end; //SmallInt
    'B': begin tmpDt.Data_type := data_int; tmpDt.idata := Byte(CallFuncInt); _hi_OnEvent(_event_onFunc, tmpDt); end;     //Byte
    'W': begin tmpDt.Data_type := data_int; tmpDt.idata := Word(CallFuncInt); _hi_OnEvent(_event_onFunc, tmpDt); end;     //Word
    //'?': _hi_OnEvent(_event_onFunc, QWord(CallFuncInt)); //????
    'L': begin tmpDt.Data_type := data_real; tmpDt.rdata := LongWord(CallFuncInt); _hi_OnEvent(_event_onFunc, tmpDt); end;  //Longword
    'I': begin tmpDt.Data_type := data_int;  tmpDt.idata := CallFuncInt; _hi_OnEvent(_event_onFunc, tmpDt); end ;  // Indeger
    'h': begin tmpDt.Data_type := data_real; tmpDt.rdata := Cardinal(CallFuncInt); _hi_OnEvent(_event_onFunc, tmpDt); end; //Handle(Cardinal)
    'S': begin tmpDt.Data_type := data_str;  tmpDt.sdata := PChar(CallFuncInt); _hi_OnEvent(_event_onFunc, tmpDt); end; // PChar
    's': begin tmpDt.Data_type := data_str;  tmpDt.sdata := PChar(CallFuncInt); _hi_OnEvent(_event_onFunc, tmpDt); end; // PChar
    'a': begin tmpDt.Data_type := data_str;  tmpDt.sdata := Char(CallFuncInt); _hi_OnEvent(_event_onFunc, tmpDt); end;  // Char
    'c': begin tmpDt.Data_type := data_real; tmpDt.rdata := Comp(CallFuncDbl); _hi_OnEvent(_event_onFunc, tmpDt); end; //Comp
    'D': begin tmpDt.Data_type := data_real; tmpDt.rdata := CallFuncDbl; _hi_OnEvent(_event_onFunc, tmpDt); end; // Double
    'd': begin tmpDt.Data_type := data_real; tmpDt.rdata := CallFuncDbl; _hi_OnEvent(_event_onFunc, tmpDt); end; //Single
    'R': begin tmpDt.Data_type := data_real; tmpDt.rdata := CallFuncDbl; _hi_OnEvent(_event_onFunc, tmpDt); end; // Real
    'C': begin tmpDt.Data_type := data_real; tmpDt.rdata := Currency(CallFuncDbl); _hi_OnEvent(_event_onFunc, tmpDt); end;   //Currency
  end;
  Param.Free;
end;


procedure THICallDllEx.LogCreate;
begin
  Case idx of
  1: _hi_OnEvent(_event_onLog, '    ');
  2: _hi_OnEvent(_event_onLog, ' ' + DllNameStr + ' ');
  3: _hi_OnEvent(_event_onLog, '   ' + DllNameStr);
  4: _hi_OnEvent(_event_onLog, '    ' + DllNameStr);
  5: _hi_OnEvent(_event_onLog, '    StreamDLL  ');
  6: _hi_OnEvent(_event_onLog, '       ');
  7: _hi_OnEvent(_event_onLog, '   '+FuncNameStr+'  ');
  8: _hi_OnEvent(_event_onLog, '  '+FuncNameStr);
  9: _hi_OnEvent(_event_onLog, 'Error - doListDLLExports = '+SysErrorMessage(GetLastError));
  end;
end;

function THICallDllEx.CallFuncInt;
asm
    mov eax,0
    mov ecx, [ParamSize]
    cmp ecx, 0    //   
    jle @gofunc
    mov ecx,0
    @lab:
    mov ebx, [Param]
    mov ebx,[ebx]
    push ebx
    sub [Param], 4
    add ecx, 4
    cmp ecx, [ParamSize]
    jne @lab
    @gofunc:
    call [Func]
    mov  dword ptr [Result], eax
    mov ecx, [CallType]
    cmp ecx, 0
    jle @endfunc
    add esp, [ParamSize] //  cdecl
    @endfunc:
end;

function THICallDllEx.CallFuncDbl;
asm
    mov eax,0
    mov ecx, [ParamSize]
    cmp ecx, 0    //   
    jle @gofunc
    mov ecx,0
    @lab:
    mov ebx, [Param]
    mov ebx,[ebx]
    push ebx
    sub [Param], 4
    add ecx, 4
    cmp ecx, [ParamSize]
    jne @lab
    @gofunc:
    call [Func]
    fstp qword ptr [Result]
    mov ecx, [CallType]
    cmp ecx, 0
    jle @endfunc
    add esp, [ParamSize] //cdecl
    @endfunc:
end;

procedure THICallDllEx._work_doDLLName;
begin
FreeLibrary(DLLHandle);
Loader.Free;
_prop_DLLName := ToString(_Data);
 if _prop_InStream then begin
    DLLStream := ReadStream(_Data, _data_StreamDll);
    Loader:=TDLLLoader.Create;
    if Loader.Load(DLLStream) then
      begin
        LogCreate(5);
      end else exit;
 end else begin
   DllNameStr := ReadString(_Data, _data_DLLName, _prop_DLLName);
   if DllNameStr <> '' then
     begin
     if FileExists(DllNameStr) then begin
       DLLHandle := LoadLibrary(PChar(DllNameStr));
       LogCreate(2);
     end else begin
       LogCreate(3);
       end;
     end else begin
       LogCreate(1);
   end;
 end;
end;

procedure THICallDllEx._work_doListDLLExports;
var
  ImageBase : DWord;
  DosHeader : PImageDosHeader;
  PeHeader  : PImageNtHeaders;
  PExport   : PImageExportDirectory;
  pname     : PDWord;
  name      : PChar;
  i         : Integer;
begin
case _prop_InStream of
 False : begin
 DllNameStr := ReadString(_Data, _data_DLLName, _prop_DLLName);
  try
    ImageBase := GetModuleHandle(PChar(DllNameStr));
    If (ImageBase = 0) Then
    begin
       ImageBase := LoadLibrary(PChar(DllNameStr));
       If (ImageBase = 0) Then
         begin
           LogCreate(9);
           exit;
         end;
    end;

    try
      DosHeader := PImageDosHeader(ImageBase);
      If (DosHeader^.Signature <> IMAGE_DOS_SIGNATURE) Then
          LogCreate(9);

      PEHeader := PImageNtHeaders(DWord(ImageBase) + DWord(DosHeader^.LFAoffset));
      If (PEHeader^.Signature <> IMAGE_NT_SIGNATURE) Then
          LogCreate(9);

      PExport := PImageExportDirectory(ImageBase +
      DWord(PEHeader^.OptionalHeader.DataDirectory[IMAGE_DIRECTORY_ENTRY_EXPORT].VirtualAddress));
      pname   := PDWord(ImageBase + DWord(PExport^.AddressOfNames));

      For i := 0 To PExport^.NumberOfNames - 1 do begin
        name := PChar(PDWord(DWord(ImageBase)  + PDword(pname)^));
        _hi_OnEvent(_event_onDLLExports, name);
        inc(pname);
      end;
    finally
      if DLLHandle = 0 then
      FreeLibrary(ImageBase);
    end;
  except
    Exit;
  end;
 end;
 True : begin
  FFuncList := Loader.GetExportList;
  for i := 0 to FFuncList.Count-1 do
  _hi_OnEvent(_event_onDLLExports, FFuncList.Items[i]);
 end;
end;
end;

procedure THICallDllEx._work_doFuncList;
 var dt: TData;
begin
   dt := _doData(FList.Items[ToInteger(_Data)]);
   _work_doCallFuncStr(dt,0);
end;

procedure THICallDllEx.SetText;
begin
   FList.Text := Value;
end;

procedure THICallDllEx._Set;
var   ind:integer;
begin
   ind := ToIntIndex(Item);
   if (ind >= 0) and (ind < FList.Count) then
      FList.Items[ind] := ToString(Val);
end;

procedure THICallDllEx._Add;
begin
   FList.Add(ToString(val));
end;

function THICallDllEx._Get;
var   ind:integer;
begin
   ind := ToIntIndex(Item);
   if (ind >= 0) and (ind < FList.Count) then begin
      Result := true;
      dtString(Val,FList.Items[ind]);
   end else
      Result := false;
end;

function THICallDllEx._Count;
begin
   Result := FList.Count;
end;

procedure THICallDllEx._var_Count;
begin
   dtInteger(_Data,FList.Count-1);
end;

procedure THICallDllEx._var_Name;
begin
   dtString(_Data,FuncNameStr);
end;

procedure THICallDllEx._var_Data;
begin
   dtData(_Data,tmpDt);
end;

procedure THICallDllEx._var_ArrFunc;
begin
   if Arr = nil then Arr := CreateArray(_Set, _Get, _Count, _Add);
   dtArray(_Data,Arr);
end;

end.
